//----------------------------------------------------------------------------
//  Project tear
//  Some Company
//  Copyright 1998. All Rights reserved.
//
//  SUBSYSTEM:    tear Application
//  FILE:         tear.cpp
//  AUTHOR:       Author
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TTearAppl (TApplication).
//  (Generated by OWL 6.0 Wizard for MS VC )
//----------------------------------------------------------------------------
#include "owlpch.h"
#include <conio.h>

/////////////////////////////////////////
//
//
//
class TTearAppl : public TApplication {
  public:
    TTearAppl() : TApplication(_T("Tear")) {}
    void 	InitInstance();
    void 	InitMainWindow();
};

void
TTearAppl::InitMainWindow()
{
	owl_string wndClass = _T("tty");
	if(TSystem::IsNT())
		wndClass = _T("ConsoleWindowClass");
  
	HWND hWnd = 0;
	
	TTmpBuffer<_TCHAR> titles(MAX_PATH);
	if(GetConsoleTitle(titles, MAX_PATH)){
		hWnd = ::FindWindow(wndClass.c_str(), titles);
		if(!hWnd){
			cerr << "Error found windows" << ends;
			getch();
		}
	}
	
	// create alias for console window
	if(hWnd)
		SetMainWindow(new TFrameWindow(hWnd, this));
}

LPCTSTR pszURL = NULL;
bool    bStripMode = false;
bool    bProgressMode = false;
TInternetSession::TOpenContext AccessType = TInternetSession::OpenPreconfig;

uint32 dwHttpRequestFlags =
	INTERNET_FLAG_EXISTING_CONNECT | INTERNET_FLAG_NO_AUTO_REDIRECT;
const TCHAR szHeaders[] =
	_T("Accept: text/*\r\nUser-Agent: OWL_NExt_Tear_Sample\r\n");

/////////////////////////////////////////////////////////////////////////////
// Routines
void ShowBanner()
{
	cerr << _T("TEAR - Tear a Page Off the Internet!") << endl;
	cerr << _T("Version 1.0 - OWL NExt example") << endl;
	cerr << endl;
}

void ShowUsage()
{
	cerr << _T("Usage:  TEAR [options] <URL>") << endl << endl;
	cerr << _T("\t<URL> points at a HTTP resource") << endl;
	cerr << _T("\t[options] are any of:") << endl;
	cerr << _T("\t\t/F force reload of requested page") << endl;
	cerr << _T("\t\t/P show detailed progress information") << endl;
	cerr << _T("\t\t/S strip HTML tags from stream") << endl << endl;
	cerr << _T("\t\t/L use local Internet access") << endl;
	cerr << _T("\t\t/D use pre-configured Internet access (default)") << endl;

	cerr << endl;
}

// ParseOptions() looks for options on the command line and sets global
// flags so the rest of the program knows about them.  ParseOptions()
// also initializes pszURL to point at the URL the user wanted.
bool ParseOptions(int argc, char* argv[])
{
	int nIndex;
	//uint32 dwAccessType = (uint32)AccessType;
	for (nIndex = 1; nIndex < argc; nIndex++){
		// an option or a URL?

		if (*argv[nIndex] == '-' || *argv[nIndex] == '/')	{
			if (argv[nIndex][1] == 'D' || argv[nIndex][1] == 'd')
				AccessType = TInternetSession::OpenPreconfig;
			else if (argv[nIndex][1] == 'L' || argv[nIndex][1] == 'l')
				AccessType = TInternetSession::OpenDirect;
			else if (argv[nIndex][1] == 'S' || argv[nIndex][1] == 's')
				bStripMode = TRUE;
			else if (argv[nIndex][1] == 'P' || argv[nIndex][1] == 'p')
				bProgressMode = TRUE;
			else if (argv[nIndex][1] == 'F' || argv[nIndex][1] == 'f')
				dwHttpRequestFlags |= INTERNET_FLAG_RELOAD;
			else{
				cerr << _T("Error: unrecognized option: ") << argv[nIndex] << endl;
				return false;
			}
		}
		else{
			// can't have too many URLs

		if (pszURL != NULL){
			cerr << _T("Error: can only specify one URL!") << endl;
			return false;
		}
		else
			pszURL = argv[nIndex];
		}
	}
	return true;
}

// StripTags() rips through a buffer and removes HTML tags from it.
// The function uses a static variable to remember its state in case
// a HTML tag spans a buffer boundary.
void StripTags(LPTSTR pszBuffer)
{
	static bool bInTag = false;
	LPTSTR pszSource = pszBuffer;
	LPTSTR pszDest = pszBuffer;

	while (*pszSource != '\0'){
		if (bInTag)	{
			if (*pszSource == '>')
				bInTag = FALSE;
			pszSource++;
		}
		else{
			if (*pszSource == '<')
				bInTag = TRUE;
			else{
				*pszDest = *pszSource;
				pszDest++;
			}
			pszSource++;
		}
	}
	*pszDest = '\0';
}

//
void CALLBACK 
InternetCallback(HINTERNET /*hInternet*/, DWORD /*dwContext*/, DWORD dwInternetStatus,
								LPVOID /*lpvStatusInformation*/, DWORD /*dwStatusInformationLength*/)
{
	if (!bProgressMode)
		return;

	if (dwInternetStatus == INTERNET_STATUS_CONNECTED_TO_SERVER)
		cerr << _T("Connection made!") << endl;
}

//
void ReportInetError()
{
	_TCHAR buffer1[MAX_PATH];
	if(TXInternet(0).GetErrorMessage(buffer1, MAX_PATH)){
		cerr << (LPTSTR)buffer1 << endl;
	}
	else
		cerr << _T("Internet unknown error") << endl;
}

//
static bool staticParseURL(LPCTSTR url, 
													 TInternetService& serviceType, 
													 owl_string& strServerName, 
													 owl_string& strObject, 
													 INTERNET_PORT& nPort)
{
	if (!TInternetConnection::ParseURL(url, serviceType,  strServerName, 
		                                 strObject, nPort)){
		// try adding the "ftp://" protocol
		owl_string strHttpURL = _T("http://");
		strHttpURL += url;

		if (!TInternetConnection::ParseURL(strHttpURL.c_str(), serviceType, 
			                                 strServerName, strObject, nPort)){
			cerr << _T("Error: Invalid URL") << endl;
			return false;
		}
	}
	return true;
}
//
void
TTearAppl::InitInstance()
{
  TApplication::InitInstance();

  // INSERT>> Your all code here.
	TInternetSession session;
	if(!session.Open(GetName(), AccessType)){
		cerr << _T("Fail to open session") << endl;
		return;
	}

	owl_string strServerName, strObject;
	INTERNET_PORT nPort;
	TInternetService serviceType;

	// check to see if this is a reasonable URL --
	// ie "http://servername/dirs" or just "servername/dirs"
	if(!staticParseURL(pszURL, serviceType, strServerName, strObject, nPort))
		return;

	if(serviceType != isServiceHttp){
		cerr << _T("Error: can only use URLs beginning with http://") << endl;
		return;
	}

	if (bProgressMode){
		cerr << _T("Opening Internet...") << endl;
		session.SetStatusCallback(InternetCallback);
	}
	
	THttpConnection connection(session);
	if(!connection.Open(strServerName.c_str(), nPort)){
		cerr << _T("Error open session...") << endl;
		ReportInetError();
		return;
	}
	THttpFile file(connection);
	if(!file.Open(THttpFile::verbGet, strObject.c_str(), NULL, 0, NULL, NULL, 
		            dwHttpRequestFlags)){
		cerr << _T("Error open http file...") << endl;
		ReportInetError();
		return;
	}
	
	file.AddRequestHeaders(szHeaders);
	file.SendRequest();
	uint32 statusCode = 0;
	file.QueryInfoStatusCode(statusCode);
	// if access was denied, prompt the user for the password
	if (statusCode == HTTP_STATUS_DENIED){
		uint32 dwPrompt = file.ErrorDlg(GetMainWindow());

		// if the user cancelled the dialog, bail out
		if (dwPrompt != ERROR_INTERNET_FORCE_RETRY){
			cerr << _T("Access denied: Invalid password\n") << endl;
			return;
		}

		file.SendRequest();
		file.QueryInfoStatusCode(statusCode);
	}
	
	TTmpBuffer<_TCHAR> buffer1(MAX_PATH);
	uint32 size = MAX_PATH;
	file.QueryInfo(HTTP_QUERY_RAW_HEADERS_CRLF,  (void*)(LPCTSTR)buffer1, size);

	// were we redirected?
	// these response status codes come from WININET.H
	if (statusCode == HTTP_STATUS_MOVED || statusCode == HTTP_STATUS_REDIRECT ||
			statusCode == HTTP_STATUS_REDIRECT_METHOD){

		LPTSTR location = _tcsstr(buffer1,_T("Location: "));
		if (!location){
			cerr << _T("Error: Site redirects with no new location") << endl;
			return;
		}
		location += 10;
		LPTSTR p = _tcschr(location,_T('\n'));
		if(p)
			*p = _T('\0');

		// close up the redirected site
		file.Close();
		connection.Close();
			
		if (bProgressMode){
			cerr << _T("Caution: redirected to ");
			cerr << location << endl;
		}
		if(!staticParseURL(buffer1, serviceType, strServerName, strObject, nPort)){
			cerr << _T("Error: the redirected URL could not be parsed.") << endl;
			return;
		}
		if(serviceType != isServiceHttp){
			cerr << _T("Error: the redirected URL does not reference a HTTP resource.") << endl;
			return;
		}

		// try again at the new location
		if(!connection.Open(strServerName.c_str(), nPort)){
			cerr << _T("Error open session...") << endl;
			return;
		}
		if(!file.Open(THttpFile::verbGet,strObject.c_str(), NULL, 0,NULL, NULL, 
			            dwHttpRequestFlags)){
			cerr << _T("Error open http file...") << endl;
			return;
		}
		file.AddRequestHeaders(szHeaders);
		file.SendRequest();
		file.QueryInfoStatusCode(statusCode);
		if (statusCode != HTTP_STATUS_OK)		{
			cerr << _T("Error: Got status code ") << statusCode << endl;
			return;
		}
	}
	cerr << _T("Status Code is ") << statusCode << endl;
	TCHAR sz[1024];
	uint32 count;
/*
	while((count = file.Read(sz, 1023)) != TFILE_ERROR && count){
		if(bStripMode)
			StripTags(sz);
		cout << sz;
	}
*/
	// NOTE: Since HTTP servers normally spit back plain text, the
	// above code (which reads line by line) is just fine.  However,
	// other data sources (eg, FTP servers) might provide binary data
	// which should be handled a buffer at a time, like this:
	count = file.Read(sz, 1023);
	while((count > 0) && (count != TFILE_ERROR))	{
		sz[count] = '\0';
		if (bStripMode)
			StripTags(sz);
		cout << sz;
		count = file.Read(sz, 1023);
	}
}

//
//
//
int OwlMain(int argc, TCHAR* argv[])
{
	ShowBanner();
	if (argc < 2 || !ParseOptions(argc, argv) || pszURL == NULL){
		ShowUsage();
		return 0;
	}
  return TTearAppl().Start();
}
//
